/* THIS FILE IS AUTOGENERATED FROM /builddir/build/BUILD/VirtualBox-3.0.10_OSE/src/VBox/GuestHost/OpenGL/packer/pack_client.c BY pack_swap.py */


/* Copyright (c) 2001, Stanford University
 * All rights reserved
 *
 * See the file LICENSE.txt for information on redistributing this software.
 */

#include "packer.h"
#include "cr_opcodes.h"
#include "cr_version.h"

/*
 * Expand glArrayElement into crPackVertex/Color/Normal/etc.SWAP
 */
void
crPackExpandArrayElementSWAP(GLint index, CRClientState *c)
{
	unsigned char *p;
	int unit;

	if (c->array.e.enabled)
	{
		crPackEdgeFlagvSWAP(c->array.e.p + index * c->array.e.stride);
	}
	for (unit = 0; unit < CR_MAX_TEXTURE_UNITS; unit++)
	{
		if (c->array.t[unit].enabled)
		{
			p = c->array.t[unit].p + index * c->array.t[unit].stride;
			switch (c->array.t[unit].type)
			{
				case GL_SHORT:
					switch (c->array.t[c->curClientTextureUnit].size)
					{
						case 1: crPackMultiTexCoord1svARBSWAP(GL_TEXTURE0_ARB + unit, (GLshort *)p); break;
						case 2: crPackMultiTexCoord2svARBSWAP(GL_TEXTURE0_ARB + unit, (GLshort *)p); break;
						case 3: crPackMultiTexCoord3svARBSWAP(GL_TEXTURE0_ARB + unit, (GLshort *)p); break;
						case 4: crPackMultiTexCoord4svARBSWAP(GL_TEXTURE0_ARB + unit, (GLshort *)p); break;
					}
					break;
				case GL_INT:
					switch (c->array.t[c->curClientTextureUnit].size)
					{
						case 1: crPackMultiTexCoord1ivARBSWAP(GL_TEXTURE0_ARB + unit, (GLint *)p); break;
						case 2: crPackMultiTexCoord2ivARBSWAP(GL_TEXTURE0_ARB + unit, (GLint *)p); break;
						case 3: crPackMultiTexCoord3ivARBSWAP(GL_TEXTURE0_ARB + unit, (GLint *)p); break;
						case 4: crPackMultiTexCoord4ivARBSWAP(GL_TEXTURE0_ARB + unit, (GLint *)p); break;
					}
					break;
				case GL_FLOAT:
					switch (c->array.t[c->curClientTextureUnit].size)
					{
						case 1: crPackMultiTexCoord1fvARBSWAP(GL_TEXTURE0_ARB + unit, (GLfloat *)p); break;
						case 2: crPackMultiTexCoord2fvARBSWAP(GL_TEXTURE0_ARB + unit, (GLfloat *)p); break;
						case 3: crPackMultiTexCoord3fvARBSWAP(GL_TEXTURE0_ARB + unit, (GLfloat *)p); break;
						case 4: crPackMultiTexCoord4fvARBSWAP(GL_TEXTURE0_ARB + unit, (GLfloat *)p); break;
					}
					break;
				case GL_DOUBLE:
					switch (c->array.t[c->curClientTextureUnit].size)
					{
						case 1: crPackMultiTexCoord1dvARBSWAP(GL_TEXTURE0_ARB + unit, (GLdouble *)p); break;
						case 2: crPackMultiTexCoord2dvARBSWAP(GL_TEXTURE0_ARB + unit, (GLdouble *)p); break;
						case 3: crPackMultiTexCoord3dvARBSWAP(GL_TEXTURE0_ARB + unit, (GLdouble *)p); break;
						case 4: crPackMultiTexCoord4dvARBSWAP(GL_TEXTURE0_ARB + unit, (GLdouble *)p); break;
					}
					break;
			}
		}
	} /* loop over texture units */

	if (c->array.i.enabled)
	{
		p = c->array.i.p + index * c->array.i.stride;
		switch (c->array.i.type)
		{
			case GL_SHORT: crPackIndexsvSWAP((GLshort *)p); break;
			case GL_INT: crPackIndexivSWAP((GLint *)p); break;
			case GL_FLOAT: crPackIndexfvSWAP((GLfloat *)p); break;
			case GL_DOUBLE: crPackIndexdvSWAP((GLdouble *)p); break;
		}
	}
	if (c->array.c.enabled)
	{
		p = c->array.c.p + index * c->array.c.stride;
		switch (c->array.c.type)
		{
			case GL_BYTE:
				switch (c->array.c.size)
				{
					case 3: crPackColor3bvSWAP((GLbyte *)p); break;
					case 4: crPackColor4bvSWAP((GLbyte *)p); break;
				}
				break;
			case GL_UNSIGNED_BYTE:
				switch (c->array.c.size)
				{
					case 3: crPackColor3ubvSWAP((GLubyte *)p); break;
					case 4: crPackColor4ubvSWAP((GLubyte *)p); break;
				}
				break;
			case GL_SHORT:
				switch (c->array.c.size)
				{
					case 3: crPackColor3svSWAP((GLshort *)p); break;
					case 4: crPackColor4svSWAP((GLshort *)p); break;
				}
				break;
			case GL_UNSIGNED_SHORT:
				switch (c->array.c.size)
				{
					case 3: crPackColor3usvSWAP((GLushort *)p); break;
					case 4: crPackColor4usvSWAP((GLushort *)p); break;
				}
				break;
			case GL_INT:
				switch (c->array.c.size)
				{
					case 3: crPackColor3ivSWAP((GLint *)p); break;
					case 4: crPackColor4ivSWAP((GLint *)p); break;
				}
				break;
			case GL_UNSIGNED_INT:
				switch (c->array.c.size)
				{
					case 3: crPackColor3uivSWAP((GLuint *)p); break;
					case 4: crPackColor4uivSWAP((GLuint *)p); break;
				}
				break;
			case GL_FLOAT:
				switch (c->array.c.size)
				{
					case 3: crPackColor3fvSWAP((GLfloat *)p); break;
					case 4: crPackColor4fvSWAP((GLfloat *)p); break;
				}
				break;
			case GL_DOUBLE:
				switch (c->array.c.size)
				{
					case 3: crPackColor3dvSWAP((GLdouble *)p); break;
					case 4: crPackColor4dvSWAP((GLdouble *)p); break;
				}
				break;
		}
	}
	if (c->array.n.enabled)
	{
		p = c->array.n.p + index * c->array.n.stride;
		switch (c->array.n.type)
		{
			case GL_BYTE: crPackNormal3bvSWAP((GLbyte *)p); break;
			case GL_SHORT: crPackNormal3svSWAP((GLshort *)p); break;
			case GL_INT: crPackNormal3ivSWAP((GLint *)p); break;
			case GL_FLOAT: crPackNormal3fvSWAP((GLfloat *)p); break;
			case GL_DOUBLE: crPackNormal3dvSWAP((GLdouble *)p); break;
		}
	}
#ifdef CR_EXT_secondary_color
	if (c->array.s.enabled)
	{
		p = c->array.s.p + index * c->array.s.stride;
		switch (c->array.s.type)
		{
			case GL_BYTE:
				crPackSecondaryColor3bvEXTSWAP((GLbyte *)p); break;
			case GL_UNSIGNED_BYTE:
				crPackSecondaryColor3ubvEXTSWAP((GLubyte *)p); break;
			case GL_SHORT:
				crPackSecondaryColor3svEXTSWAP((GLshort *)p); break;
			case GL_UNSIGNED_SHORT:
				crPackSecondaryColor3usvEXTSWAP((GLushort *)p); break;
			case GL_INT:
				crPackSecondaryColor3ivEXTSWAP((GLint *)p); break;
			case GL_UNSIGNED_INT:
				crPackSecondaryColor3uivEXTSWAP((GLuint *)p); break;
			case GL_FLOAT:
				crPackSecondaryColor3fvEXTSWAP((GLfloat *)p); break;
			case GL_DOUBLE:
				crPackSecondaryColor3dvEXTSWAP((GLdouble *)p); break;
		}
	}
#endif
	if (c->array.v.enabled)
	{
		p = c->array.v.p + (index * c->array.v.stride);
		switch (c->array.v.type)
		{
			case GL_SHORT:
				switch (c->array.v.size)
				{
					case 2: crPackVertex2svBBOX_COUNTSWAP((GLshort *)p); break;
					case 3: crPackVertex3svBBOX_COUNTSWAP((GLshort *)p); break;
					case 4: crPackVertex4svBBOX_COUNTSWAP((GLshort *)p); break;
				}
				break;
			case GL_INT:
				switch (c->array.v.size)
				{
					case 2: crPackVertex2ivBBOX_COUNTSWAP((GLint *)p); break;
					case 3: crPackVertex3ivBBOX_COUNTSWAP((GLint *)p); break;
					case 4: crPackVertex4ivBBOX_COUNTSWAP((GLint *)p); break;
				}
				break;
			case GL_FLOAT:
				switch (c->array.v.size)
				{
					case 2: crPackVertex2fvBBOX_COUNTSWAP((GLfloat *)p); break;
					case 3: crPackVertex3fvBBOX_COUNTSWAP((GLfloat *)p); break;
					case 4: crPackVertex4fvBBOX_COUNTSWAP((GLfloat *)p); break;
				}
				break;
			case GL_DOUBLE:
				switch (c->array.v.size)
				{
					case 2: crPackVertex2dvBBOX_COUNTSWAP((GLdouble *)p); break;
					case 3: crPackVertex3dvBBOX_COUNTSWAP((GLdouble *)p); break;
					case 4: crPackVertex4dvBBOX_COUNTSWAP((GLdouble *)p); break;
				}
				break;
		}
	}
}


void
crPackExpandDrawArraysSWAP(GLenum mode, GLint first, GLsizei count, CRClientState *c)
{
	int i;

	if (count < 0)
	{
		__PackError(__LINE__, __FILE__, GL_INVALID_VALUE, "crPackDrawArraysSWAP(negative count)");
		return;
	}

	if (mode > GL_POLYGON)
	{
		__PackError(__LINE__, __FILE__, GL_INVALID_ENUM, "crPackDrawArraysSWAP(bad mode)");
		return;
	}

	crPackBeginSWAP(mode);
	for (i=0; i<count; i++)
	{
		crPackExpandArrayElementSWAP(first + i, c);
	}
	crPackEndSWAP();
}


/*
 * Really pack glDrawElements (for server-side vertex arrays)
 * Note: we pack the pointer (which is actually an index into the server-side
 * vertex buffer) and not the actual indices.
 */
void PACK_APIENTRY
crPackDrawElementsSWAP(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices)
{
	unsigned char *data_ptr;
	int packet_length = sizeof(int) + sizeof(mode) + sizeof(count) + sizeof(type) + sizeof(GLintptrARB);
	data_ptr = (unsigned char *) crPackAlloc(packet_length);
	WRITE_DATA( 0, GLenum, SWAP32(CR_DRAWELEMENTS_EXTEND_OPCODE) );
	WRITE_DATA( 4, GLenum, SWAP32(mode) );
	WRITE_DATA( 8, GLsizei, SWAP32(count) );
	WRITE_DATA( 12, GLenum, SWAP32(type) );
	WRITE_DATA( 16, GLsizeiptrARB, SWAP32((GLsizeiptrARB) indices) );
	crHugePacket( CR_EXTEND_OPCODE, data_ptr );
	crPackFree( data_ptr );
}


/**
 * Expand glDrawElements into crPackBegin/Vertex/End,SWAP etc commands.
 * Note: if mode==999, don't call glBegin/glEnd.
 */
void
crPackExpandDrawElementsSWAP(GLenum mode, GLsizei count, GLenum type,
												 const GLvoid *indices, CRClientState *c)
{
	int i;

	if (count < 0)
	{
		__PackError(__LINE__, __FILE__, GL_INVALID_VALUE,
								"crPackDrawElementsSWAP(negative count)");
		return;
	}

	if (mode > GL_POLYGON && mode != 999)
	{
		__PackError(__LINE__, __FILE__, GL_INVALID_ENUM,
								"crPackDrawElementsSWAP(bad mode)");
		return;
	}

	if (type != GL_UNSIGNED_BYTE &&
			type != GL_UNSIGNED_SHORT &&
			type != GL_UNSIGNED_INT)
	{
		__PackError(__LINE__, __FILE__, GL_INVALID_ENUM,
								"crPackDrawElementsSWAP(bad type)");
		return;
	}

	if (mode != 999)
		crPackBeginSWAP(mode);

	switch (type)	{
	case GL_UNSIGNED_BYTE:
		{
			const GLubyte *p = (const GLubyte *) indices;
			for (i = 0; i < count; i++)
				crPackExpandArrayElementSWAP(p[i], c);
		}
		break;
	case GL_UNSIGNED_SHORT:
		{
			const GLushort *p = (const GLushort *) indices;
			for (i=0; i<count; i++)
				crPackExpandArrayElementSWAP(p[i], c);
		}
		break;
	case GL_UNSIGNED_INT:
		{
			const GLuint *p = (const GLuint *) indices;
			for (i = 0; i < count; i++)
				crPackExpandArrayElementSWAP(p[i], c);
		}
		break;
	default:
		__PackError( __LINE__, __FILE__, GL_INVALID_ENUM,
								 "crPackDrawElementsSWAP(bad type)");
		break;
	}

	if (mode != 999)
		crPackEndSWAP();
}


/**
 * Convert a glDrawElements command into a sequence of ArrayElement() calls.
 * NOTE: Caller must issue the glBegin/glEnd.
 */
void
crPackUnrollDrawElementsSWAP(GLsizei count, GLenum type,
												 const GLvoid *indices)
{
	int i;

	switch (type) {
	case GL_UNSIGNED_BYTE:
		{
			const GLubyte *p = (const GLubyte *) indices;
			for (i = 0; i < count; i++)
				crPackArrayElementSWAP(p[i]);
		}
		break;
	case GL_UNSIGNED_SHORT:
		{
			const GLushort *p = (const GLushort *) indices;
			for (i = 0; i < count; i++)
				crPackArrayElementSWAP(p[i]);
		}
		break;
	case GL_UNSIGNED_INT:
		{
			const GLuint *p = (const GLuint *) indices;
			for (i = 0; i < count; i++)
				crPackArrayElementSWAP(p[i]);
		}
		break;
	default:
		__PackError(__LINE__, __FILE__, GL_INVALID_ENUM,
								 "crPackUnrollDrawElementsSWAP(bad type)");
	}
}



/*
 * Really pack glDrawRangeElements (for server-side vertex arrays)
 * Note: we pack the pointer (which is actually an index into the server-side
 * vertex buffer) and not the actual indices.
 */
void PACK_APIENTRY
crPackDrawRangeElementsSWAP(GLenum mode, GLuint start, GLuint end, GLsizei count,
												GLenum type, const GLvoid *indices)
{
	unsigned char *data_ptr;
	int packet_length = sizeof(int) + sizeof(mode) + sizeof(start)
		+ sizeof(end) + sizeof(count) + sizeof(type) + sizeof(GLintptrARB);

	data_ptr = (unsigned char *) crPackAlloc(packet_length);
	WRITE_DATA( 0, GLenum, SWAP32(CR_DRAWRANGEELEMENTS_EXTEND_OPCODE) );
	WRITE_DATA( 4, GLenum, SWAP32(mode) );
	WRITE_DATA( 8, GLuint, SWAP32(start) );
	WRITE_DATA( 12, GLuint, SWAP32(end) );
	WRITE_DATA( 16, GLsizei, SWAP32(count) );
	WRITE_DATA( 20, GLenum, SWAP32(type) );
	WRITE_DATA( 24, GLsizeiptrARB, SWAP32((GLsizeiptr) indices) );
	crHugePacket( CR_EXTEND_OPCODE, data_ptr );
	crPackFree( data_ptr );
}


/*
 * glDrawRangeElements, expanded into crPackBegin/Vertex/End/etc.SWAP
 */
void
crPackExpandDrawRangeElementsSWAP(GLenum mode, GLuint start, GLuint end, GLsizei count, GLenum type, const GLvoid *indices, CRClientState *c)
{
	int i;
	GLubyte *p = (GLubyte *)indices;

	(void) end;

	if (count < 0)
	{
		__PackError(__LINE__, __FILE__, GL_INVALID_VALUE, "crPackDrawRangeElementsSWAP(negative count)");
		return;
	}

	if (mode > GL_POLYGON)
	{
		__PackError(__LINE__, __FILE__, GL_INVALID_ENUM, "crPackDrawRangeElementsSWAP(bad mode)");
		return;
	}

	if (type != GL_UNSIGNED_BYTE && type != GL_UNSIGNED_SHORT && type != GL_UNSIGNED_INT)
	{
		__PackError(__LINE__, __FILE__, GL_INVALID_ENUM, "crPackDrawRangeElementsSWAP(bad type)");
		return;
	}

	crPackBeginSWAP(mode);
	switch (type)
	{
	case GL_UNSIGNED_BYTE:
		for (i=0; i<count; i++)
		{
			crPackExpandArrayElementSWAP((GLint) *p++, c);
		}
		break;
	case GL_UNSIGNED_SHORT:
		for (i=0; i<count; i++)
		{
			crPackExpandArrayElementSWAP((GLint) * (GLushort *) p, c);
			p += sizeof(GLushort);
		}
		break;
	case GL_UNSIGNED_INT:
		for (i=0; i<count; i++)
		{
			crPackExpandArrayElementSWAP((GLint) * (GLuint *) p, c);
			p += sizeof(GLuint);
		}
		break;
	default:
		crError( "this can't happen: crPackDrawRangeElementsSWAP" );
		break;
	}
	crPackEndSWAP();
}


#ifdef CR_EXT_multi_draw_arrays
/*
 * Pack real DrawArrays commands.
 */
void PACK_APIENTRY
crPackMultiDrawArraysEXTSWAP( GLenum mode, GLint *first, GLsizei *count,
													GLsizei primcount )
{
   GLint i;
   for (i = 0; i < primcount; i++) {
      if (count[i] > 0) {
         crPackDrawArraysSWAP(mode, first[i], count[i]);
      }
   }
}


/*
 * Pack with crPackBegin/Vertex/End/etc.SWAP
 */
void
crPackExpandMultiDrawArraysEXTSWAP( GLenum mode, GLint *first, GLsizei *count,
																GLsizei primcount, CRClientState *c )
{
   GLint i;
   for (i = 0; i < primcount; i++) {
      if (count[i] > 0) {
         crPackExpandDrawArraysSWAP(mode, first[i], count[i], c);
      }
   }
}


/*
 * Pack real DrawElements commands.
 */
void PACK_APIENTRY
crPackMultiDrawElementsEXTSWAP( GLenum mode, const GLsizei *count, GLenum type,
                            const GLvoid **indices, GLsizei primcount )
{
   GLint i;
   for (i = 0; i < primcount; i++) {
      if (count[i] > 0) {
         crPackDrawElementsSWAP(mode, count[i], type, indices[i]);
      }
   }
}


/*
 * Pack with crPackBegin/Vertex/End/etc.SWAP
 */
void
crPackExpandMultiDrawElementsEXTSWAP( GLenum mode, const GLsizei *count,
																	GLenum type, const GLvoid **indices,
																	GLsizei primcount, CRClientState *c )
{
   GLint i;
   for (i = 0; i < primcount; i++) {
      if (count[i] > 0) {
         crPackExpandDrawElementsSWAP(mode, count[i], type, indices[i], c);
      }
   }
}
#endif /* CR_EXT_multi_draw_arrays */
