/* Copyright (c) 2001, Stanford University
	All rights reserved.

	See the file LICENSE.txt for information on redistributing this software. */
	

/* DO NOT EDIT - THIS FILE AUTOMATICALLY GENERATED BY server_retval.py SCRIPT */
#include "chromium.h"
#include "cr_mem.h"
#include "cr_net.h"
#include "server_dispatch.h"
#include "server.h"

void crServerReturnValue( const void *payload, unsigned int payload_len )
{
    CRMessageReadback *rb;
    int msg_len = sizeof( *rb ) + payload_len;

    /* Don't reply to client if we're loading VM snapshot*/
    if (cr_server.bIsInLoadingState)
        return;

    if (cr_server.curClient->conn->type == CR_FILE)
    {
        return;
    }

    rb = (CRMessageReadback *) crAlloc( msg_len );

    rb->header.type = CR_MESSAGE_READBACK;
    crMemcpy( &(rb->writeback_ptr), &(cr_server.writeback_ptr), sizeof( rb->writeback_ptr ) );
    crMemcpy( &(rb->readback_ptr), &(cr_server.return_ptr), sizeof( rb->readback_ptr ) );
    crMemcpy( rb+1, payload, payload_len );
    crNetSend( cr_server.curClient->conn, NULL, rb, msg_len );
    crFree( rb );
}

GLuint SERVER_DISPATCH_APIENTRY crServerDispatchCreateProgram( void )
{
	GLuint retval;
	retval = cr_server.head_spu->dispatch_table.CreateProgram(  );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLuint SERVER_DISPATCH_APIENTRY crServerDispatchCreateShader( GLenum type )
{
	GLuint retval;
	retval = cr_server.head_spu->dispatch_table.CreateShader( type );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLuint SERVER_DISPATCH_APIENTRY crServerDispatchGenLists( GLsizei range )
{
	GLuint retval;
	retval = cr_server.head_spu->dispatch_table.GenLists( range );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLint SERVER_DISPATCH_APIENTRY crServerDispatchGetAttribLocation( GLuint program, const char * name )
{
	GLint retval;
	retval = cr_server.head_spu->dispatch_table.GetAttribLocation( program, name );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLenum SERVER_DISPATCH_APIENTRY crServerDispatchGetError( void )
{
	GLenum retval;
	retval = cr_server.head_spu->dispatch_table.GetError(  );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLhandleARB SERVER_DISPATCH_APIENTRY crServerDispatchGetHandleARB( GLenum pname )
{
	GLhandleARB retval;
	retval = cr_server.head_spu->dispatch_table.GetHandleARB( pname );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLint SERVER_DISPATCH_APIENTRY crServerDispatchGetUniformLocation( GLuint program, const char * name )
{
	GLint retval;
	retval = cr_server.head_spu->dispatch_table.GetUniformLocation( program, name );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLboolean SERVER_DISPATCH_APIENTRY crServerDispatchIsBufferARB( GLuint buffer )
{
	GLboolean retval;
	retval = cr_server.head_spu->dispatch_table.IsBufferARB( buffer );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLboolean SERVER_DISPATCH_APIENTRY crServerDispatchIsEnabled( GLenum cap )
{
	GLboolean retval;
	retval = cr_server.head_spu->dispatch_table.IsEnabled( cap );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLboolean SERVER_DISPATCH_APIENTRY crServerDispatchIsFenceNV( GLuint fence )
{
	GLboolean retval;
	retval = cr_server.head_spu->dispatch_table.IsFenceNV( fence );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLboolean SERVER_DISPATCH_APIENTRY crServerDispatchIsProgram( GLuint program )
{
	GLboolean retval;
	retval = cr_server.head_spu->dispatch_table.IsProgram( program );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLboolean SERVER_DISPATCH_APIENTRY crServerDispatchIsQueryARB( GLuint id )
{
	GLboolean retval;
	retval = cr_server.head_spu->dispatch_table.IsQueryARB( id );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLboolean SERVER_DISPATCH_APIENTRY crServerDispatchIsShader( GLuint shader )
{
	GLboolean retval;
	retval = cr_server.head_spu->dispatch_table.IsShader( shader );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLint SERVER_DISPATCH_APIENTRY crServerDispatchRenderMode( GLenum mode )
{
	GLint retval;
	retval = cr_server.head_spu->dispatch_table.RenderMode( mode );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
GLboolean SERVER_DISPATCH_APIENTRY crServerDispatchTestFenceNV( GLuint fence )
{
	GLboolean retval;
	retval = cr_server.head_spu->dispatch_table.TestFenceNV( fence );
	crServerReturnValue( &retval, sizeof(retval) );
	return retval; /* WILL PROBABLY BE IGNORED */
}
